
#define gui_set_text(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_text(Z,Y);} while(0)
#define gui_get_text(X) \
 ({typeof(X)* _Z= &(X); char *_K= _Z->cls->get_text(_Z); _K;})
#define gui_set_value(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_value(Z,Y);} while(0)

#define gui_list_append(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->append_item(Z, __VA_ARGS__ ); } while(0)

#define gui_list_get_selected(X,Y) \
 ({ typeof(X)* Z= &(X); int _K= Z->cls->get_selected(Z,Y); _K; })

#define gui_print(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->print(Z, __VA_ARGS__ ); } while(0)

#define gui_clear(X) \
 do { typeof(X)* Z= &(X); Z->cls->clear(Z); } while(0)


typedef struct gui_radio_group gui_radio_group_t;

typedef struct {
  void (*set_value)(struct gui_radio_group *, int);
  void (*get_value)(struct gui_radio_group*, int *);
} gui_radio_group_class_t;

struct gui_radio_group
{
  gui_radio_group_class_t *cls;
  void *widget;
};

 typedef struct gui_label gui_label_t;

typedef struct {
  void (*set_text)(struct gui_label *,char *);
} gui_label_class_t;

struct gui_label {
  gui_label_class_t *cls;
  void *widget;
};

  
typedef struct gui_slist gui_slist_t;

typedef struct {
   int  (*get_selected)(gui_slist_t *, char**);
   void (*append)(gui_slist_t *, const char *,const char*);
   void (*prepend)(gui_slist_t *, const char *,const char*);
   void (*insert)(gui_slist_t *, const char* , const char *,const char*);
   void (*remove)(gui_slist_t *,const char *);
} gui_slist_class_t;

struct gui_slist {
  gui_slist_class_t *cls;
  void *widget;
};

  typedef struct gui_button gui_button_t;

typedef struct {
  void (*set_text)(struct gui_button *,const char *);
} gui_button_class_t;

struct gui_button {
  gui_button_class_t *cls;
  void *widget;
};

   

  typedef struct gui_check_box gui_check_box_t;
  typedef struct {
     void (*get_value)(gui_check_box_t *,int *);
     void (*set_value)(gui_check_box_t *,int);
  } gui_check_box_class_t;
  struct gui_check_box {
    gui_check_box_class_t *cls;
    void *widget;
  };

     typedef struct gui_spinner gui_spinner_t;

typedef struct {
  void (*set_value)(struct gui_spinner *,int );
  void (*get_value)(struct gui_spinner *,int *);
} gui_spinner_class_t;

struct gui_spinner {
  gui_spinner_class_t *cls;
  void *widget;
};

     typedef struct gui_text_entry gui_text_entry_t;

typedef struct {
  void (*set_text)(struct gui_text_entry *,char *);
  char* (*get_text)(struct gui_text_entry *);
} gui_text_entry_class_t;

struct gui_text_entry {
  gui_text_entry_class_t *cls;
  void *widget;
};

     
 typedef struct gui_message_console gui_message_console_t;

 typedef struct {
    void (*print)(gui_message_console_t *,const char *,...);
    void (*clear)(gui_message_console_t *);
 } gui_message_console_class_t;

 struct gui_message_console {
    gui_message_console_class_t *cls;
    void *widget;
 };


  
typedef struct gui_dir_list gui_dir_list_t;

typedef struct {
   int (*get_current)(gui_dir_list_t *, const char **, int *);
   void (*set_current_file)(gui_dir_list_t* , const char*);
   void (*set_current_dir)(gui_dir_list_t* , const char*);
} gui_dir_list_class_t;

struct gui_dir_list
{
   gui_dir_list_class_t *cls;
   void *widget;
};


  
 typedef struct gui_text_viewer gui_text_viewer_t;

 typedef struct {
    void (*clear)(gui_text_viewer_t *);
    void (*set_text)(gui_text_viewer_t *,const char*);
 } gui_text_viewer_class_t;

 struct gui_text_viewer {
    gui_text_viewer_class_t *cls;
    void *widget;
 };


   
#ifdef __cplusplus
extern "C" {
#endif

void gui_init(int *argc,char **argv);
void gui_run();
void gui_flush();

#ifdef __cplusplus
}
#endif

typedef struct {
  void *self;
gui_radio_group_t eof_indicator;

gui_radio_group_t alarm;



   gui_slist_t source_dirs;

 

  

  

    gui_check_box_t size_limit_on;

    gui_spinner_t size_limit;

    

    gui_text_entry_t destdir;

    

    gui_text_entry_t eof_file;

    

    gui_text_entry_t alarm_file;

    

    

    gui_text_entry_t alarm_player;

    

    

    

  gui_spinner_t gui_check_period;

  

  

  

  

  
 gui_message_console_t status;

  
} gui_main_t;

#ifdef __cplusplus
extern "C" {
#endif

gui_main_t *gui_c_main();

#ifdef __cplusplus
}
#endif


typedef struct gui_dir_selector gui_dir_selector_t;

typedef struct {
   int (*execute)(gui_dir_selector_t *);
   void (*close)(gui_dir_selector_t *);
} YQRZ_176;

struct gui_dir_selector {
  YQRZ_176 *cls;
  void *self;

  gui_dir_list_t dirs;

 gui_text_entry_t dir_name;

 

  

  

   
};

#ifdef __cplusplus
extern "C" {
#endif

gui_dir_selector_t *gui_c_dir_selector(void *owner);

#ifdef __cplusplus
}
#endif


typedef struct gui_dest_selector gui_dest_selector_t;

typedef struct {
   int (*execute)(gui_dest_selector_t *);
   void (*close)(gui_dest_selector_t *);
} YQRZ_213;

struct gui_dest_selector {
  YQRZ_213 *cls;
  void *self;

  gui_dir_list_t dirs;

 gui_text_entry_t dir_name;

 

  

   
};

#ifdef __cplusplus
extern "C" {
#endif

gui_dest_selector_t *gui_c_dest_selector(void *owner);

#ifdef __cplusplus
}
#endif


typedef struct gui_help gui_help_t;

typedef struct {
   int (*execute)(gui_help_t *);
   void (*close)(gui_help_t *);
} YQRZ_255;

struct gui_help {
  YQRZ_255 *cls;
  void *self;

 gui_text_viewer_t text;

 

  

  

  

   
};

#ifdef __cplusplus
extern "C" {
#endif

gui_help_t *gui_c_help(void *owner);

#ifdef __cplusplus
}
#endif

 



#define gui_get_value(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->get_value(_Z, __VA_ARGS__ ); } while(0)

 #define gui_execute(X) ({typeof(X)* _Z= &(X); _Z->cls->execute(_Z); })

#define gui_close(X) do { typeof(X)* _Z= &(X); _Z->cls->close(_Z); } while(0)

#define gui_get_current(X, ...) ({ typeof(X)* _Z= &(X); _Z->cls->get_current(_Z, __VA_ARGS__ ); })
#define gui_set_current_file(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_file(_Z, __VA_ARGS__ ); } while(0)

#define gui_set_current_dir(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_dir(_Z, __VA_ARGS__ ); } while(0)

#define gui_append(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->append(_Z, __VA_ARGS__ ); } while(0)

#define gui_remove(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->remove(_Z, __VA_ARGS__ ); } while(0)


